"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/

/* eslint-env node */

/* eslint-disable flowtype/require-valid-file-annotation */
var scenarios = require('./examples-list');

var _require = require('../../e2e/helpers'),
    getPuppeteerUrl = _require.getPuppeteerUrl,
    analyzeAccessibility = _require.analyzeAccessibility;

var suite = 'Tabs Test Suite';
describe(suite, function () {
  beforeAll(
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return page.goto(getPuppeteerUrl({
              suite: suite,
              test: scenarios.STATEFUL_TABS_EXAMPLE
            }));

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  })));
  it('passes basic a11y tests',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    var accessibilityReport;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return page.waitFor('[role="tab"]');

          case 2:
            _context2.next = 4;
            return analyzeAccessibility(page);

          case 4:
            accessibilityReport = _context2.sent;
            expect(accessibilityReport).toHaveNoAccessibilityIssues();

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  })));
  it('changes content on tab click',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3() {
    var states, i, visible, _i, _visible;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return page.waitFor('[role="tab"]');

          case 2:
            // verifiy initial state, tab 0 is visible, tab 1 and 2 are hidden
            states = [true, false, false];
            i = 0;

          case 4:
            if (!(i < states.length)) {
              _context3.next = 13;
              break;
            }

            _context3.next = 7;
            return page.$eval("[aria-labelledby=\"".concat(i, "\"]"), function (input) {
              return !!input.offsetParent;
            });

          case 7:
            visible = _context3.sent;
            _context3.next = 10;
            return expect(visible).toBe(states[i]);

          case 10:
            i++;
            _context3.next = 4;
            break;

          case 13:
            _context3.next = 15;
            return page.click('[id="1"]');

          case 15:
            states = [false, true, false];
            _i = 0;

          case 17:
            if (!(_i < states.length)) {
              _context3.next = 26;
              break;
            }

            _context3.next = 20;
            return page.$eval("[aria-labelledby=\"".concat(_i, "\"]"), function (input) {
              return !!input.offsetParent;
            });

          case 20:
            _visible = _context3.sent;
            _context3.next = 23;
            return expect(_visible).toBe(states[_i]);

          case 23:
            _i++;
            _context3.next = 17;
            break;

          case 26:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  })));
});